<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): /home/mohamed/code/tigl/src/common/containers/tiglVertexImplementation.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_5e9011f35b9434939eeeb25c7dbf1304.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglVertexImplementation.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglVertexImplementation_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef TIGLVERTEX_IMPLEMENTATION_HPP_</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define TIGLVERTEX_IMPLEMENTATION_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a><a class="code" href="classVertex.html">::</a></div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="classVertex.html#a144983fc25f8daec86625edd56ce82a2">   17</a></span>&#160;<a class="code" href="classVertex.html">Vertex</a>(IdType key, <span class="keywordtype">bool</span> noMessageFlag, <span class="keywordtype">bool</span> inFlagReactivate):</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <a class="code" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt; (key)</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;{</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="comment">//disableListedActive();</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <a class="code" href="classVertex.html#a39af26a364ed0b0b02dded453f212dd4">activeWithNoMessage</a> = noMessageFlag;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <a class="code" href="classVertex.html#a4d3dbce66b581ee792f0860d5473ad47">reactivateFlag</a> = inFlagReactivate;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;}</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a><a class="code" href="classVertex.html">::</a></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<a class="code" href="classVertex.html">Vertex</a>(IdType key, DataType data, AlgDataType alg, <span class="keywordtype">bool</span> noMessageFlag, <span class="keywordtype">bool</span> inFlagReactivate):</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <a class="code" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt; (key, data, alg)</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;{</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="comment">//disableListedActive();</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <a class="code" href="classVertex.html#a39af26a364ed0b0b02dded453f212dd4">activeWithNoMessage</a> = noMessageFlag;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <a class="code" href="classVertex.html#a4d3dbce66b581ee792f0860d5473ad47">reactivateFlag</a> = inFlagReactivate;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;}</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a><a class="code" href="classVertex.html">::</a></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<a class="code" href="classVertex.html">Vertex</a>(IdType key):</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <a class="code" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt; (key)</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;}</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment">// empty constructor</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a><a class="code" href="classVertex.html">::</a></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<a class="code" href="classVertex.html">Vertex</a>(): <a class="code" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt; ()</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;{</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;}</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a><a class="code" href="classVertex.html">::</a></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<a class="code" href="classVertex.html">	Vertex</a>(IdType key, DataType data, AlgDataType alg):</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <a class="code" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt; (key, data, alg)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;{</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;}</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;~Vertex()</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;{</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;}</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment">//public:</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="comment">// disable the node</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keywordtype">void</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classVertex.html#a91f156ad92a87e52f8f3eb9925b6aa5f">   70</a></span>&#160;setParams(IdType key, DataType data, AlgDataType alg)</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;{</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    this-&gt;<span class="keywordtype">id</span> = key;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    this-&gt;algData = alg;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    this-&gt;vertexData = data;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;}</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="classVertex.html#a8da96efbfde6073f47940c46c0acbac3">   79</a></span>&#160;vote_to_halt()</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;{</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    flagActive = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;}</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="classVertex.html#ad4d81194f3d15e28724b5397dd6f8057">   86</a></span>&#160;isActive()</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;{</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordflow">return</span> flagActive;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;}</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">//  check if the vertex stays active even without messages</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="classVertex.html#aa28f23add98dfce6a5479b99c06af2d1">   94</a></span>&#160;isActiveWithNoMessage()</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;{</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordflow">return</span> activeWithNoMessage;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;}</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment">//  clear vertex contents</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keywordtype">void</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00103"></a><span class="lineno"><a class="line" href="classVertex.html#a8ae7863a14aa94dd662d5177f2f21d6a">  103</a></span>&#160;clear()</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;{</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <a class="code" href="classVertexBase.html">TIGLContainersVertexBase&lt;DataType, AlgDataType, EdgeType, IdType&gt;::clear</a>();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    flagActive = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;}</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment">//  check if the vertex can be reactivated by new messages</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classVertex.html#a052ec7617bb9517859b3c161aa30e7ff">  112</a></span>&#160;canReactivate()</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;{</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">return</span> reactivateFlag;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;}</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment">//  activating the node</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="classVertex.html#a69d93758d3b0925e0a56bcbb347d4523">  121</a></span>&#160;activate()</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;{</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;}</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment">//  //==================================================================================================================</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="comment">//  virtual core compute function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment">//  pIn pointer to the input message buffer</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment">//   pOut pointer to the output message buffer</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="comment">//  numMessages the number of input data messages</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="comment">//  returns the number of output data messages</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt; uint_fast32_t</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="classVertex.html#a7539009c0bf5fc9f247a159e273fedb5">  135</a></span>&#160;compute(MESSAGE_BUF_TYPE *pIn,</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                    vector &lt;MESSAGE_TYPE, ALLOCATOR_TYPE&gt; *pOut,</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                    uint_fast32_t numMessages)</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;{</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;}</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">// virtual core init function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">// initParams pointer to the initialization parameters</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment">// pOut pointer to the output message buffer</span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="comment">//returns the number of output data messages</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt; uint_fast32_t</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00150"></a><span class="lineno"><a class="line" href="classVertex.html#a351a476ae7f2d930857bdd973bcbbbc8">  150</a></span>&#160;init(INIT_TYPE *initParams,</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;                vector &lt;MESSAGE_TYPE, ALLOCATOR_TYPE&gt; *pOut)</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;{</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;}</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;uint_fast32_t <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00159"></a><span class="lineno"><a class="line" href="classVertex.html#ad415db584d2b07288ae68cc9b36a976e">  159</a></span>&#160;getMessageBufSize()</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;{</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="keywordflow">return</span> (this-&gt;outEdges).capacity()*<span class="keyword">sizeof</span>(MESSAGE_TYPE);</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;}</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType , <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a>::</div>
<div class="line"><a name="l00166"></a><span class="lineno"><a class="line" href="classVertex.html#ad8503c72e2946374b868377ce7cf6738">  166</a></span>&#160;setAggPtr(<a class="code" href="classAggInfo.html">AGGREGATE_TYPE</a>    * infoPtr)</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;{</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <a class="code" href="classVertex.html">Vertex&lt;DataType, AlgDataType, EdgeType, InitType, IdType, MessageType&gt;::aggregateInfoPtr</a> = infoPtr;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    <span class="comment">//aggregateInfoPtr = infoPtr;</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;}</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType&gt;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classBiVertex.html">TIGLContainersBiVertex &lt;DataType, AlgDataType, EdgeType, IdType&gt;</a>::</div>
<div class="line"><a name="l00175"></a><span class="lineno"><a class="line" href="classBiVertex.html#a9747019e5c8c2f6b42fc5cd2e00555cb">  175</a></span>&#160;vote_to_halt()</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;{</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    flagActive = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;}</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType&gt;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classBiVertex.html">TIGLContainersBiVertex &lt;DataType, AlgDataType, EdgeType, IdType &gt;</a>::</div>
<div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="classBiVertex.html#aef74aee8efe56f81bfc6d79e86eb639e">  182</a></span>&#160;isActive()</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;{</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keywordflow">return</span> flagActive;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;}</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType&gt;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classBiVertex.html">TIGLContainersBiVertex &lt;DataType, AlgDataType, EdgeType, IdType&gt;</a>::</div>
<div class="line"><a name="l00189"></a><span class="lineno"><a class="line" href="classBiVertex.html#aa5a9dd6d7e4b32a5d67c0db36b850c79">  189</a></span>&#160;activate()</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;{</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;}</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment">// defining the static members</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, </div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="keyword">typename</span> IdType, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<a class="code" href="classAggInfo.html">TIGLContainersAggregate&lt;AlgDataType&gt;</a>* <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a> ::aggregateInfoPtr;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, </div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="keyword">typename</span> IdType, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;::activeWithNoMessage</a>;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, </div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="keyword">typename</span> IdType, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classVertex.html">Vertex &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;::reactivateFlag</a>;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLVERTEXIMPLEMENTATION_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classVertex_html_a39af26a364ed0b0b02dded453f212dd4"><div class="ttname"><a href="classVertex.html#a39af26a364ed0b0b02dded453f212dd4">Vertex::activeWithNoMessage</a></div><div class="ttdeci">static bool activeWithNoMessage</div><div class="ttdoc">a flag when true the vertex is processed even with no message, if false it is processed only if there...</div><div class="ttdef"><b>Definition:</b> tiglAPIVertex.hpp:54</div></div>
<div class="ttc" id="classVertex_html_a4d3dbce66b581ee792f0860d5473ad47"><div class="ttname"><a href="classVertex.html#a4d3dbce66b581ee792f0860d5473ad47">Vertex::reactivateFlag</a></div><div class="ttdeci">static bool reactivateFlag</div><div class="ttdoc">a flag when true the vertex can be reactivated by new messages, otherwise it never wake up once becom...</div><div class="ttdef"><b>Definition:</b> tiglAPIVertex.hpp:57</div></div>
<div class="ttc" id="classVertexBase_html"><div class="ttname"><a href="classVertexBase.html">TIGLContainersVertexBase</a></div><div class="ttdoc">core vertex class that contains all the vertex data and defines all vertex mutations It is a template...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:47</div></div>
<div class="ttc" id="tiglVertex_8hpp_html"><div class="ttname"><a href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a></div><div class="ttdoc">core vertex class definitions for TIGL </div></div>
<div class="ttc" id="classBiVertex_html"><div class="ttname"><a href="classBiVertex.html">TIGLContainersBiVertex</a></div><div class="ttdef"><b>Definition:</b> tiglAPIVertex.hpp:132</div></div>
<div class="ttc" id="classAggInfo_html"><div class="ttname"><a href="classAggInfo.html">TIGLContainersAggregate</a></div><div class="ttdoc">base class for aggregate information it holds important aggregate information and methods for updatin...</div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:80</div></div>
<div class="ttc" id="classVertex_html"><div class="ttname"><a href="classVertex.html">Vertex</a></div><div class="ttdoc">core vertex class for Pregel Engine (with only output edge buffer). It inherits the core vertex class...</div><div class="ttdef"><b>Definition:</b> tiglAPIVertex.hpp:39</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Jan 27 2015 12:14:00 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
